﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Text.RegularExpressions;

namespace VezLego
{
    public partial class Form1 : Form
    {
        int xVeze, yVeze;
        string typVeze;
        List<UmistenaKostka> kostky;
        int patroKZobrazeni;
        int stranaKZobrazeni;

        public Form1()
        {
            InitializeComponent();
            kostky = new List<UmistenaKostka>();
            patroKZobrazeni = 1;
            stranaKZobrazeni = 1;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            Stream s;
            StreamReader sr;

            if (ofd.ShowDialog() == DialogResult.OK)
            {
                if ((s = ofd.OpenFile()) != null)
                {
                    //otevirani souboru a rozdeleni udaju na prvni radce regulernim vyrazem
                    sr = new StreamReader(s);
                    List<string> vez = new List<string>();
                    Regex regulerniVyraz = new Regex(@"\w+");
                    foreach (Match vysledek in regulerniVyraz.Matches(sr.ReadLine()))
                    {
                        vez.Add(vysledek.ToString());
                    }
                    xVeze = int.Parse(vez[0]);
                    yVeze = int.Parse(vez[1]);
                    typVeze = vez[2];

                    while (sr.Peek() > -1)
                    {
                        //projizdeni zbylych radek a nacteni udaju do seznamu kostek
                        List<string> udajeKostka = new List<string>();
                        string[] rozmery = new string[10];
                        foreach (Match vysledek in regulerniVyraz.Matches(sr.ReadLine())){
                            udajeKostka.Add(vysledek.ToString());
                        }
                        if (udajeKostka[4].Contains("x")){
                            rozmery = udajeKostka[4].Split('x');
                        }
                        else if (udajeKostka[4].Contains("X"))
                        {
                            rozmery = udajeKostka[4].Split('X');
                        }
                        
                        UmistenaKostka kostka = new UmistenaKostka(int.Parse(udajeKostka[0]), int.Parse(udajeKostka[1]), int.Parse(udajeKostka[2]), udajeKostka[3], int.Parse(rozmery[0]), int.Parse(rozmery[1]));
                        kostky.Add(kostka);
                    }
                    zpracuj();
                }
            }
        }

        private void zpracuj()
        {
            //obsluhujici metoda volajici vykresleni patra, veze a seznamu pouzitych kostek
            vypsatKostky();
            zobrazitPatro(1);
            zobrazitStranu(1);
        }
        private void vypsatKostky()
        {            
            //vypsani kostek ze sezanamu
            foreach (UmistenaKostka k in kostky)
            {
                string parametry = "Patro: " + k.patro + " X: " + k.x + " Y: " + k.y + " Barva: " + k.barva + " Šířka: " + k.sirka + " Délka: " + k.delka;
                richTextBox1.Text += parametry + Environment.NewLine;
            }
        }
        private void zobrazitPatro(int patro)
        {
            label3.Text = patroKZobrazeni.ToString() + ". patro";
            panel2.Invalidate();
        }
        private void zobrazitStranu(int strana)
        {
            label1.Text = stranaKZobrazeni.ToString() + ". strana";
            panel1.Invalidate();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            patroKZobrazeni++;
            zobrazitPatro(patroKZobrazeni);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            patroKZobrazeni--;
            zobrazitPatro(patroKZobrazeni);
        }

      private void panel2_Paint(object sender, PaintEventArgs e)
        {
          //kresleni patra
            Graphics g = e.Graphics;
            int zvetseni = xVeze * yVeze / 4;
            int posun = zvetseni * 2;

            if (kostky.Count != 0)
            {
                IEnumerable<UmistenaKostka> vyber = kostky.Where(kostka => kostka.patro == patroKZobrazeni);
                foreach (UmistenaKostka k in vyber)
                {
                    Color barva = new Color();
                    Point lokace = new Point(k.x*zvetseni+posun, k.y*zvetseni);
                    Size velikost = new Size(k.sirka*zvetseni, k.delka*zvetseni);
                    switch (k.barva)
                    {
                        case "A":
                            barva = Color.FromArgb(0, 255, 255);
                            break;
                        case "R":
                            barva = Color.FromArgb(255, 0, 0);
                            break;
                        case "G":
                            barva = Color.FromArgb(0, 255, 0);
                            break;
                        case "B":
                            barva = Color.FromArgb(0, 0, 255);
                            break;
                        case "Y":
                            barva = Color.FromArgb(255, 255, 0);
                            break;

                    }
                    Pen pero = new Pen(Color.Black);
                    Brush stetec = new SolidBrush(barva);
                    g.FillRectangle(stetec, new Rectangle(lokace, velikost));                    
                    g.DrawRectangle(pero, new Rectangle(lokace, velikost));

                }
            }
            
        }

      private void panel1_Paint(object sender, PaintEventArgs e)
      {
          //kresleni strany
          Graphics g = e.Graphics;
          if (kostky.Count != 0)
          {
              IEnumerable<UmistenaKostka> vyber = kostky.Where(kostka => kostka.x == 1);
              foreach (UmistenaKostka k in vyber)
              {
                  Point lokace = new Point(k.x+50, k.patro);
                  Size velikost = new Size(k.sirka * 5, k.patro * 5);
                  Pen pero = new Pen(Color.Black);
                  g.DrawRectangle(pero, new Rectangle(lokace, velikost));
              }
          }

      }

      private void button2_Click(object sender, EventArgs e)
      {
          if (stranaKZobrazeni == 4)
              stranaKZobrazeni = 1;
          else
              stranaKZobrazeni++;   
          zobrazitStranu(stranaKZobrazeni);

      }

      private void button3_Click(object sender, EventArgs e)
      {
          if (stranaKZobrazeni == 1)
              stranaKZobrazeni = 4;
          else
              stranaKZobrazeni--;
          zobrazitStranu(stranaKZobrazeni);

      }
    }
}
